#include <stdlib.h>

#include "Menu.h"
#include "World.h"

int Screen = STITLE;
double IconX = -0.31;
double IconY = -0.01;

World World1 = LoadWorld();

char* GetLevelByFile()
{
 return World1.Current->Filename;     
}

void OutOfGame()
{
 Screen = SWORLD;          
}

char* GetWorldName()
{
 return World1.Name;     
}

char* GetLevelName()
{
 return World1.Current->Name;     
}

double GetWorldX()
{
 return World1.Current->X;      
}

double GetWorldY()
{
 return World1.Current->Y;      
}

void DecreaseMenuOption()
{
 if(Screen == STITLE)
 {
  IconX = -0.31;
  IconY += 0.09;
  if(IconY > 0.0) IconY = -0.19;
 }   
 else if(Screen == SWORLD)
 {
  World1 = prevLevel(World1);
 }                   
}

void IncreaseMenuOption()
{
 if(Screen == STITLE)
 {
  IconX = -0.31;
  IconY -= 0.09;
  if(IconY < -0.2) IconY = -0.01;
 }         
 else if(Screen == SWORLD)
 {
  World1 = nextLevel(World1);
 }         
}

bool InGame()
{
 if(Screen == SDONE) return true;
 else return false;    
}

void SwitchInHelpMenu()
{
 Screen++;
 if(Screen > SHELP3) Screen = STITLE;        
}

int GetScreen() { return Screen; }
double GetMenuX() { return IconX; }
double GetMenuY() { return IconY; }

void ProcessOption()
{
 if(Screen == STITLE) 
 {
  if(IconY > -0.03) Screen = SWORLD;
  if(IconY < -0.03 && IconY > -0.12) SwitchInHelpMenu(); 
  if(IconY < -0.12) exit(0);
 }
 else if(Screen < SWORLD)
  SwitchInHelpMenu();   
 else if(Screen == SWORLD) Screen = SDONE;
}

bool DeProcessOption()
{
 if(Screen == STITLE) 
 {
  freeWList(World1);
  return true;
 }
 else Screen = STITLE;
 return false;
}
