#include <stdio.h>
#include <stdlib.h>

#include "WallTile.h"

WallTile MakeWallTile(StopType pBlocking)
//This function sets up the initial spot as based on the stoptype provided.
//Things like making it dirty and colouring the spot and all that other fun stuff
//is actually done by the Level.  In my code, a Level is an Array of Walls.  So
//check that out for more info on walls.
{
 WallTile newTile;
 newTile.Blocking = pBlocking;     
 newTile.Colour = ISGREY;
 newTile.Dirty = false;
 newTile.Hole = false;

 if(newTile.Blocking == BNONE) { newTile.Blocks[0] = false; newTile.Blocks[1] = false; newTile.Blocks[2] = false; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BNORTH) { newTile.Blocks[0] = true; newTile.Blocks[1] = false; newTile.Blocks[2] = false; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BEAST)  { newTile.Blocks[0] = false; newTile.Blocks[1] = true; newTile.Blocks[2] = false; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BSOUTH)  { newTile.Blocks[0] = false; newTile.Blocks[1] = false; newTile.Blocks[2] = true; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BWEST)  { newTile.Blocks[0] = false; newTile.Blocks[1] = false; newTile.Blocks[2] = false; newTile.Blocks[3] = true; }
 else if(newTile.Blocking == BNORTHEAST)  { newTile.Blocks[0] = true; newTile.Blocks[1] = true; newTile.Blocks[2] = false; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BNORTHSOUTH)  { newTile.Blocks[0] = true; newTile.Blocks[1] = false; newTile.Blocks[2] = true; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BNORTHWEST)  { newTile.Blocks[0] = true; newTile.Blocks[1] = false; newTile.Blocks[2] = false; newTile.Blocks[3] = true; }
 else if(newTile.Blocking == BEASTSOUTH)  { newTile.Blocks[0] = false; newTile.Blocks[1] = true; newTile.Blocks[2] = true; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BEASTWEST)  { newTile.Blocks[0] = false; newTile.Blocks[1] = true; newTile.Blocks[2] = false; newTile.Blocks[3] = true; }
 else if(newTile.Blocking == BSOUTHWEST)  { newTile.Blocks[0] = false; newTile.Blocks[1] = false; newTile.Blocks[2] = true; newTile.Blocks[3] = true; }
 else if(newTile.Blocking == BNORTHEASTSOUTH)  { newTile.Blocks[0] = true; newTile.Blocks[1] = true; newTile.Blocks[2] = true; newTile.Blocks[3] = false; }
 else if(newTile.Blocking == BEASTSOUTHWEST)  { newTile.Blocks[0] = false; newTile.Blocks[1] = true; newTile.Blocks[2] = true; newTile.Blocks[3] = true; }
 else if(newTile.Blocking == BSOUTHWESTNORTH)  { newTile.Blocks[0] = true; newTile.Blocks[1] = false; newTile.Blocks[2] = true; newTile.Blocks[3] = true; }
 else if(newTile.Blocking == BWESTNORTHEAST)  { newTile.Blocks[0] = true; newTile.Blocks[1] = true; newTile.Blocks[2] = false; newTile.Blocks[3] = true; } 
 else if(newTile.Blocking == BALL)  { newTile.Blocks[0] = true; newTile.Blocks[1] = true; newTile.Blocks[2] = true; newTile.Blocks[3] = true; }
// printf("Set to: %d  ", newTile.Blocking); 
 return newTile;
}
