#include<stdlib.h>
#include <stdio.h>

#include "World.h"

//At the moment, my source code only makes ONE world.
//Don't worry, I'll change this later when I get more game content
//together.  As it is, I've only got a few levels.
//If you wanna contribute, go get my Editor and give me a hand with this thing.

World MakeEmptyWorld()
{
 World newWorld; 
 newWorld.Name = "World 1 : Frozen Fields";
 newWorld.Head = NULL;
 newWorld.Current = newWorld.Head;
     
 return newWorld;
}

void freeWList(World theList)
{
	theList.Current = theList.Head;
	while (theList.Current != NULL) 
	{ 	 
		theList.Current = theList.Head->next;
		free(theList.Head);
		theList.Head = theList.Current;
	}	
}

World nextLevel(World theWorld)
{
 if(theWorld.Current->next != NULL)
   theWorld.Current = theWorld.Current->next;
 
 return theWorld;     
}

World prevLevel(World theWorld)
{
 if(theWorld.Current->prev != NULL)
   theWorld.Current = theWorld.Current->prev;     

 return theWorld;
}

World AddLevel(World theList, char* pName, char* pFile, double pX, double pY)
{      
	LevelNode* newNode = (LevelNode*) malloc(sizeof(LevelNode));	

    newNode->Filename = pFile;
	newNode->Name = pName;
    newNode->X = pX;
    newNode->Y = pY;

    newNode->prev = NULL;
	newNode->next = NULL;

	if (theList.Head == NULL)
	{
		theList.Head = newNode;
		theList.Current = theList.Head;
	}
	else
	{
		theList.Current = theList.Head;  
		while(theList.Current->next != NULL)
		{
			theList.Current = theList.Current->next;
        }

		theList.Current->next = newNode;
		newNode->prev = theList.Current;
	}

	return theList;            
}

World ResetWorld(World theWorld)
{
 theWorld.Current = theWorld.Head;
 return theWorld;
}

World LoadWorld()
{
 int i;
 
 World theWorld; 
 theWorld = MakeEmptyWorld();
 
 FILE* NewWorld = fopen("1.wld","r");

 if (!NewWorld)
 {
  printf("World not found.\r\n");
  exit(1);
 }

 char nextLine[60];	
 
 while(fgets(nextLine,60,NewWorld) != NULL)
 {
  double X, Y;
  char* Filename = (char*) malloc(512);
  char* Name = (char*) malloc(512);
  sscanf(nextLine, "%lf %lf %s %s", &X, &Y, Filename, Name);
  printf("%f %f %s %s\n", X, Y, Filename, Name);
  theWorld = AddLevel(theWorld, Name, Filename, X, Y);
 }
 
 fclose(NewWorld);
 theWorld = ResetWorld(theWorld);
 return theWorld;
}
